package cn.edu.sdu.virion.common;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.lang.reflect.Array;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import cn.edu.sdu.virion.support.database.DBHelper;
import cn.edu.sdu.virion.support.file.FileHelper;

/**
 * 
 * @author Administrator
 *
 */
public class Util {
	
	/**
	 * ͳĳеĳִ
	 * @param composition 
	 * @return 
	 */
	public static int compositionCount(String sequence, String composition)
	{
		String content = sequence;
		String word = composition;
		int count = 0;
		int start = 0;
		while (content.indexOf(word, start) >= 0 && start < content.length()) {
			count++;
			start = content.indexOf(word, start) + word.length();
		}
		return count;
	}
	
	public static String transform(String originalSequence, String[] group, String groupLeader)
	{
		int groupCount = group.length;
		char[] seq = originalSequence.toCharArray();
		for (int i = 0; i < seq.length; i++)
		{
			for(int j=0; j < groupCount; j++)
			{
				if (-1 != group[j].indexOf(seq[i])) {
					seq[i] = groupLeader.charAt(j);
					break;
				}
			}
		}
		return String.valueOf(seq);
	}
	
	public static String prepareSvmInput(String sql, int featureNum, String featurePrefix, boolean qidNeeded)
	{
		StringBuilder content = new StringBuilder();
        Object[] params = new Object[]{};
        ResultSet rs = DBHelper.executeQuery(sql, params);
        try {
			while(rs.next()){
				StringBuilder sb = new StringBuilder();
				for (int i = 1; i <= featureNum; i++) {
					sb.append(String.format(" %d:%f", i, rs.getFloat(featurePrefix + i)));
				}
				if (true == qidNeeded) {
					content.append(String.format("%d qid:%d %s\n", 
							rs.getInt("SEQCLASS"),
							rs.getInt("ID"),
							sb.toString()));
				} else {
					content.append(String.format("%d %s\n", 
							rs.getInt("SEQCLASS"),
							sb.toString()));
				}
				
				
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
        DBHelper.free(rs);
        
        return content.toString();
	}
	
	/**
	 * ƵMap -> ƵMap
	 * @param countsMap ƵMap
	 * @param total Ƶʻ
	 * @return ƵMap
	 */
	public static Map countToFrequency(Map countsMap, int total)
	{
		// ʼƵ
		Map<Object,Float> frequencyMap = new HashMap<Object,Float>();
		
		// Ƶ
		Iterator iterator = countsMap.keySet().iterator();
		while(iterator.hasNext()) {
			Object key = iterator.next();
			int value = (int)countsMap.get(key);	
			frequencyMap.put(key, (float)value/total);
		}
		
		return frequencyMap;
	}
	
	/**
	 * üΪ1ĵȲ
	 * @param min Сֵ
	 * @param max ֵ
	 * @return ͨ
	 */
	public static int[] range(int min, int max)
	{
		int len = max - min + 1;
		int array[] = new int[len];
		for (int i = 0; i < len; i++) {
			array[i] = min + i;
		}
		return array;
	}
	
	/**
	 * ݿеݵΪFASTAʽļ
	 */
	public static void exportFasta(String sql, String outputFilePath)
	{
		StringBuilder sb = new StringBuilder();
		Object[] params = new Object[]{};
        ResultSet rs = DBHelper.executeQuery(sql, params);
        try {
			while(rs.next()){
				sb.append(String.format(">%s\n%s\n", rs.getString("ACC_ID"), rs.getString("SEQUENCE")));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
        DBHelper.free(rs);
        FileHelper.filePutContents(outputFilePath, sb.toString());
	}
	
	public static void createTable(int index, int featuresNum, String fieldPre, String templateFileName)
	{
		String templatePath = System.getProperty("user.dir") + "\\resources\\" + templateFileName;
		String sqlTemplate = FileHelper.fileGetContents(templatePath);
		StringBuilder fields = new StringBuilder();
		for (int i = 1; i <= featuresNum; i++)
			fields.append(String.format("[%s%d] [float] NULL,\n", fieldPre, i));
		String sql = sqlTemplate.replaceAll("#index#", String.valueOf(index))
				.replaceAll("#fields#", fields.toString());
		DBHelper.executeNonQuery(sql);
		System.out.println(sql);
	}
	
	
	public static void saveToDb(Map<Integer,Integer> map, int did)
	{
		Iterator<Integer> iterator = map.keySet().iterator();
		String sql = "INSERT INTO TEMP(DID,NEIBOURNUM,COUNTNUM) values(?,?,?)";
		String sqlFormat =  "INSERT INTO temp_graph_count(did,neibournum,countnum) values(%d,%d,%d);";
		while(iterator.hasNext()) {
			int key = iterator.next();
			int value = map.get(key);
			Object[] params = new Object[]{did, key, value};
			DBHelper.executeNonQuery(sql, params);
			System.out.println(String.format(sqlFormat, did, key, value));
		}
	}
	
	public static Map<Integer,Integer> count(String filePath)
	{
		Map<Integer,Integer> countsMap = new HashMap<Integer,Integer>();
		File file = new File(filePath);
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new FileReader(file));
			String line = null;
			while ((line = reader.readLine()) != null) {
				int key = numCount(line) - 1;	// ھӸ
				int value = countsMap.get(key) == null ? 0 : countsMap.get(key);
				countsMap.put(key, value+1);
			}
			countsMap.put(0, countsMap.get(0) - 1);	// ųݵӰ
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e1) {
				}
			}
		}
		return countsMap;
	}
	
	public static int numCount(String str)
	{
		int count = 0;
		Pattern pattern = Pattern.compile("\\d+");    
        Matcher matcher = pattern.matcher(str);    
        while(matcher.find()) 
            count++;  
		return count;
	}
	
	
	
}
