package cn.edu.sdu.virion.core;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import cn.edu.sdu.virion.common.Constants;
import cn.edu.sdu.virion.common.Util;

/**
 * 
 * @author Administrator
 *
 */
public class Sequence {
	
	private String sequence;

	public String getSequence() {
		return sequence;
	}

	public Sequence(String sequence) {
		super();
		this.sequence = sequence;
	}
	
	/**
	 * г
	 * @return г
	 */
	public int getLength()
	{
		return this.sequence.length();
	}
	
	/**
	 * ͳ20ְĳִ
	 * @return
	 */
	public Map getAcidsCounts()
	{
		// ʼƵ
		Map<Character,Integer> countsMap = new HashMap<Character,Integer>();
		for (char c : Constants.AMINOACIDS) { 
			countsMap.put(c, 0); 
		}
		// Ƶ
		for (Character c:this.sequence.toCharArray()) {
			countsMap.put(c,countsMap.get(c)+1);
		}
		return countsMap;
	}
	
	/**
	 * ͳ20ְĳƵ
	 * @return
	 */
	public Map getAcidsFrequency()
	{	
		return Util.countToFrequency(this.getAcidsCounts(), this.sequence.length());
	}
	
	/**
	 * ͳĳеĳִ
	 * @param composition 
	 * @return 
	 */
	public int compositionCount(String composition)
	{
		String content = this.sequence;
		String word = composition;
		int count = 0;
		int start = 0;
		while (content.indexOf(word, start) >= 0 && start < content.length()) {
			count++;
			start = content.indexOf(word, start) + word.length();
		}
		return count;
	}
	
	/**
	 * ͳиϵƵ
	 * @param compositions 
	 * @return ƵMap
	 */
	public Map<String, Integer> compositionsCounts(String[] compositions)
	{
		Map<String,Integer> countsMap = new HashMap<String,Integer>();
		for (String s : compositions)
			countsMap.put(s, this.compositionCount(s)); 
		return countsMap;
	}
	
	/**
	 * ͳжְϵĳƵ
	 * @param compositions ְ
	 * @return ƵMap
	 */
	public Map<String, Float> compositionFrequency(String[] compositions)
	{
		Map<String, Integer> countsMap = this.compositionsCounts(compositions);
		int total = this.sequence.length();
		Map<String,Float> frequencyMap = new HashMap<String,Float>();
		// Ƶ
		Iterator<String> iterator = countsMap.keySet().iterator();
		while(iterator.hasNext()) {
			String key = iterator.next();
			int value = countsMap.get(key);
			frequencyMap.put(key, (float)value/(total-key.length()+1));
		}
		
		return frequencyMap;
	}

	/**
	 * ͬ鰱滻ת
	 * @param group 
	 * @param groupLeader 
	 * @return غ
	 */
	public String transform(String[] group, String groupLeader)
	{
		int groupCount = group.length;
		char[] seq = this.sequence.toCharArray();
		for (int i = 0; i < seq.length; i++)
		{
			for(int j=0; j < groupCount; j++)
			{
				if (-1 != group[j].indexOf(seq[i])) {
					seq[i] = groupLeader.charAt(j);
					break;
				}
			}
		}
		return String.valueOf(seq);
	}
	
	/**
	 * Ϊɵ
	 * @return
	 */
	public int[] getIndexSequence()
	{
		int seqLen = this.sequence.length();
		int data[] = new int[seqLen];
		for (int i = 0; i < seqLen; i++) 
			data[i] = index(this.sequence.charAt(i));
		return data;
	}
	
	/**
	 * ðӦֵ
	 * @param c 
	 * @return ֵ
	 */
	public int index(Character c) 
	{
		for (int i = 0; i < Constants.AMINOACIDS.length; i++) 
			if (c == Constants.AMINOACIDS[i])
				return i;
		return -1;
	}

}
