package cn.edu.sdu.virion.feature.selection;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import weka.classifiers.Classifier;
import weka.core.Instances;
import cn.edu.sdu.virion.support.database.DBHelper;
import cn.edu.sdu.virion.support.weka.Classify;

public class BiBayes extends BaseSelection{

	private String featureSourceTable;
	private String attrTypeName;
	private int featuresNum;
	private int seqclassIndex;
	private int attributeStartIndex;
	private int selected_attr_num;
	private int selected_num_trees;
	private int selected_num_features;
	
	/**
	 * 캯
	 */
	public BiBayes() {
		this.featureSourceTable = "CDHIT_SEQS_BIGRAM_11";
		this.featuresNum = 100;
		this.seqclassIndex = 2;
		this.attributeStartIndex = 7;
		this.selected_attr_num = 55;
		this.selected_num_trees = 45;
		this.selected_num_features = 5;
		this.attrTypeName = "BiGram";
	}

	/**
	 * ¼¼
	 */
	public void generateInsertSQL()
	{
		List<String> list = new ArrayList<String>();
		list.addAll(attrNameList("BiGram_", 1, featuresNum));
		for (String name : list) {
			System.out.println(String.format(insertTemplate, "BiGram", name));
		}
	}
	
	/**
	 * Ȩ
	 */
	public void updateWeight() {
		try {
			super.updateWeight(featureSourceTable,seqclassIndex,attributeStartIndex,featuresNum, 105);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void attributeSelectionAll() throws SQLException {
		OneByOne("BiGram", 1, featuresNum, featureSourceTable,
				seqclassIndex);
	}
	
	public void test_A() throws Exception {
		super.test(featureSourceTable, featuresNum, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_2_A");
	}
	
	public void test() throws Exception {
		super.test(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_2");
	}
	
	/**
	 * ģļ
	 * @throws Exception
	 */
	public void generateModelFile() throws Exception {
		super.generateModelFile(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features);
	}
	
	/**
	 * ģͲύ
	 * @param jobid
	 * @throws Exception
	 */
	public void testWebSeqsUseModel(String jobid) throws Exception {
		super.testWebSeqsUseModel(jobid, selected_attr_num, attrTypeName, seqclassIndex, "SCORE_2");
	}
	
	public void testAll() throws Exception {
		super.testAll(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_2");
	}
	
	public void getSelectedFeaturesSql() throws Exception {
		super.getSelectedFeaturesSql(featureSourceTable, selected_attr_num, attrTypeName);
	}
	
	public String getSelectedFeaturesStr() throws SQLException {
		return super.getSelectedFeaturesStr(this.selected_attr_num, this.attrTypeName);
	}
}
