package cn.edu.sdu.virion.feature.selection;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class PsePP extends BaseSelection{

	private String featureSourceTable;
	private String attrTypeName;
	private int featuresNum;
	private int seqclassIndex;
	private int attributeStartIndex;
	private int selected_attr_num;
	private int selected_num_trees;
	private int selected_num_features;
	
	/**
	 * 캯
	 */
	public PsePP() {
		this.featureSourceTable = "CDHIT_SEQS_PSEAAC_5";
		this.featuresNum = 50;
		this.seqclassIndex = 2;
		this.attributeStartIndex = 7;
		this.selected_attr_num = 32;
		this.selected_num_trees = 35;
		this.selected_num_features = 10;
		this.attrTypeName = "PseAAC";
	}
	
	public void generateInsertSQL()
	{
		List<String> list = new ArrayList<String>();
		list.addAll(attrNameList("PseAAC_", 1, featuresNum));
		for (String name : list) {
			System.out.println(String.format(insertTemplate, "PseAAC", name));
		}
	}
	
	/**
	 * Ȩ
	 */
	public void updateWeight() {
		try {
			super.updateWeight(featureSourceTable,seqclassIndex,attributeStartIndex,featuresNum, 205);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void attributeSelectionAll() throws SQLException {
		OneByOne("PseAAC", 1, featuresNum, featureSourceTable,
				seqclassIndex);
	}
	
	public void test_A() throws Exception {
		super.test(featureSourceTable, featuresNum, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_3_A");
	}
	
	public void test() throws Exception {
		super.test(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_3");
	}
	
	/**
	 * ģļ
	 * @throws Exception
	 */
	public void generateModelFile() throws Exception {
		super.generateModelFile(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features);
	}
	
	/**
	 * ģͲύ
	 * @param jobid
	 * @throws Exception
	 */
	public void testWebSeqsUseModel(String jobid) throws Exception {
		String trainSql = String.format("SELECT * FROM %s WHERE STATUS=1", featureSourceTable);
		String testSqlFormat = " SELECT * FROM ( "
				+ " SELECT * FROM WEB_SEQS WHERE ID=1 ) AS A " + " UNION ALL "
				+ " SELECT * FROM ( "
				+ " SELECT * FROM WEB_SEQS WHERE JOBID='%s' ) AS B ";
		String testSql = String.format(testSqlFormat, jobid);
//		String testSql = String.format("select * FROM %s WHERE STATUS=0", featureSourceTable);

		this.updateScores("WEB_SEQS", selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_3", trainSql, testSql);
	}
	
	public void testWebSeqsWithoutModelFile(String jobid) throws Exception {
		super.testWebSeqsUseModelWithoutSaveModel(jobid, selected_attr_num,
				attrTypeName, seqclassIndex, "SCORE_3", super.generateModel(
						featureSourceTable, selected_attr_num, attrTypeName,
						seqclassIndex, selected_num_trees,
						selected_num_features));
	}
	
	public void testAll() throws Exception {
		super.testAll(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_3");
	}
	
	public void getSelectedFeaturesSql() throws Exception {
		super.getSelectedFeaturesSql(featureSourceTable, selected_attr_num, attrTypeName);
	}
	
	public String getSelectedFeaturesStr() throws SQLException {
		return super.getSelectedFeaturesStr(this.selected_attr_num, this.attrTypeName);
	}
}
