package cn.edu.sdu.virion.feature.selection;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class PsePSSM2 extends BaseSelection{
	
	private String featureSourceTable;
	private String attrTypeName;
	private int featuresNum;
	private int seqclassIndex;
	private int attributeStartIndex;
	private int selected_attr_num;
	private int selected_num_trees;
	private int selected_num_features;
	
	/**
	 * 캯
	 */
	public PsePSSM2() {
		this.featureSourceTable = "CDHIT_SEQS_PSSM_2_7";
		this.featuresNum = 121;
		this.seqclassIndex = 2;
		this.attributeStartIndex = 7;
		this.selected_attr_num = 50;
		this.selected_num_trees = 40;
		this.selected_num_features = 20;
		this.attrTypeName = "PSSM2";
	}
	
	public void generateInsertSQL()
	{
		List<String> list = new ArrayList<String>();
		list.addAll(attrNameList("PsePSSM2_", 1, featuresNum));
		for (String name : list) {
			System.out.println(String.format(insertTemplate, "PSSM2", name));
		}
	}
	
	/**
	 * Ȩ
	 */
	public void updateWeight() {
		try {
			super.updateWeight(featureSourceTable,seqclassIndex,attributeStartIndex,featuresNum, 335);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void attributeSelectionAll() throws SQLException {
		OneByOne("PSSM2", 1, 42, featureSourceTable,
				seqclassIndex);
	}
	
	public void test_A() throws Exception {
		super.test(featureSourceTable, featuresNum, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_5_A");
	}
	
	public void test() throws Exception {
		super.test(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_5");
	}
	
	/**
	 * ģļ
	 * @throws Exception
	 */
	public void generateModelFile() throws Exception {
		super.generateModelFile(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features);
	}
	
	/**
	 * ģͲύ
	 * @param jobid
	 * @throws Exception
	 */
	public void testWebSeqsUseModel(String jobid) throws Exception {
		super.testWebSeqsUseModel(jobid, selected_attr_num, attrTypeName, seqclassIndex, "SCORE_5");
	}
	
	public void testAll() throws Exception {
		super.testAll(featureSourceTable, selected_attr_num, attrTypeName, seqclassIndex, selected_num_trees, selected_num_features, "SCORE_5");
	}
	
	public void getSelectedFeaturesSql() throws Exception {
		super.getSelectedFeaturesSql(featureSourceTable, selected_attr_num, attrTypeName);
	}
	
	public String getSelectedFeaturesStr() throws SQLException {
		String str =  super.getSelectedFeaturesStr(this.selected_attr_num, this.attrTypeName);
		str = str.replaceAll("PsePSSM2_","PsePSSM_");		
		return str;
	}
}
