package cn.edu.sdu.virion.support.database;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Map;
import java.util.Map.Entry;

import cn.edu.sdu.virion.common.Constants;

public final class DBHelper {

	private static Connection conn = null;

	// ˷Ϊȡݿ

	public static Connection getConnection() {

		try {

			String driver = Constants.DB_DRIVER; // ݿ

			String url = Constants.DB_URL;// ݿ

			String user = Constants.DB_USER; // û

			String password = Constants.DB_PSWD; // 

			Class.forName(driver); // ݿ

			if (null == conn) {

				conn = DriverManager.getConnection(url, user, password);

			}

		} catch (ClassNotFoundException e) {

			System.out.println("Sorry,can't find the Driver!");

			e.printStackTrace();

		} catch (SQLException e) {

			e.printStackTrace();

		} catch (Exception e) {

			e.printStackTrace();

		}

		return conn;

	}

	/**
	 * 
	 * ɾġAddDelUpdate
	 * 
	 *
	 * 
	 * @param sql
	 * 
	 * @return int
	 */

	public static int executeNonQuery(String sql) {

		int result = 0;

		Connection conn = null;

		Statement stmt = null;

		try {

			conn = getConnection();

			stmt = conn.createStatement();

			result = stmt.executeUpdate(sql);

		} catch (SQLException err) {

			err.printStackTrace();

			free(null, stmt, conn);

		} finally {

			//free(null, stmt, conn);

		}

		return result;

	}

	/**
	 * ɾġAddDeleteUpdate
	 *
	 * @param sql
	 * @param obj
	 * @return int
	 */

	public static int executeNonQuery(String sql, Object... obj) {
		int result = 0;
		Connection conn = null;
		PreparedStatement pstmt = null;
		try {
			conn = getConnection();
			pstmt = conn.prepareStatement(sql);
			for (int i = 0; i < obj.length; i++) {
				pstmt.setObject(i + 1, obj[i]);
			}
			result = pstmt.executeUpdate();

		} catch (SQLException err) {
			err.printStackTrace();
			free(null, pstmt, conn);
		} finally {
			// free(null, pstmt, conn);
		}
		return result;
	}

	/**
	 * 
	 * 顾Query
	 * 
	 *
	 * 
	 * @param sql
	 * 
	 * @return ResultSet
	 */

	public static ResultSet executeQuery(String sql) {
		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		try {
			conn = getConnection();
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql);
		} catch (SQLException err) {
			err.printStackTrace();
			free(rs, stmt, conn);
		}
		return rs;
	}

	/**
	 * 顾Query
	 *
	 * @param sql
	 * @param obj
	 * @return ResultSet
	 */

	public static ResultSet executeQuery(String sql, Object... obj) {

		Connection conn = null;

		PreparedStatement pstmt = null;

		ResultSet rs = null;

		try {

			conn = getConnection();

			pstmt = conn.prepareStatement(sql);

			for (int i = 0; i < obj.length; i++) {

				pstmt.setObject(i + 1, obj[i]);

			}

			rs = pstmt.executeQuery();

		} catch (SQLException err) {

			err.printStackTrace();

			free(rs, pstmt, conn);

		}

		return rs;

	}

	/**
	 * 
	 * жϼ¼Ƿ
	 * 
	 *
	 * 
	 * @param sql
	 * 
	 * @return Boolean
	 */

	public static Boolean isExist(String sql) {

		ResultSet rs = null;

		try {

			rs = executeQuery(sql);

			rs.last();

			int count = rs.getRow();

			if (count > 0) {

				return true;

			} else {

				return false;

			}

		} catch (SQLException err) {

			err.printStackTrace();

			free(rs);

			return false;

		} finally {

			free(rs);

		}

	}

	/**
	 * 
	 * жϼ¼Ƿ
	 * 
	 *
	 * 
	 * @param sql
	 * 
	 * @return Boolean
	 */

	public static Boolean isExist(String sql, Object... obj) {

		ResultSet rs = null;
		try {
			rs = executeQuery(sql, obj);
			rs.last();
			int count = rs.getRow();
			if (count > 0) {
				return true;
			} else {
				return false;
			}

		} catch (SQLException err) {
			err.printStackTrace();
			free(rs);
			return false;
		} finally {
			free(rs);
		}

	}

	/**
	 * 
	 * ȡѯ¼
	 * @param sql
	 * @return int
	 */

	public static int getCount(String sql) {
		int result = 0;
		ResultSet rs = null;
		try {
			rs = executeQuery(sql);
			rs.last();
			result = rs.getRow();
		} catch (SQLException err) {
			free(rs);
			err.printStackTrace();
		} finally {
			free(rs);
		}
		return result;
	}

	/**
	 * 
	 * ȡѯ¼
	 * @param sql
	 * @param obj
	 * @return int
	 */

	public static int getCount(String sql, Object... obj) {

		int result = 0;
		ResultSet rs = null;
		try {
			rs = executeQuery(sql, obj);
			rs.last();
			result = rs.getRow();
		} catch (SQLException err) {
			err.printStackTrace();
		} finally {
			free(rs);
		}
		return result;

	}

	/**
	 * 
	 * ͷšResultSetԴ
	 * 
	 *
	 * 
	 * @param rs
	 */

	public static void free(ResultSet rs) {
		try {
			if (rs != null) {
				rs.close();
			}
		} catch (SQLException err) {
			err.printStackTrace();
		}
	}

	/**
	 * 
	 * ͷšStatementԴ
	 * @param st
	 */

	public static void free(Statement st) {

		try {

			if (st != null) {

				st.close();

			}

		} catch (SQLException err) {

			err.printStackTrace();

		}

	}

	/**
	 * 
	 * ͷšConnectionԴ
	 * @param conn
	 */

	public static void free(Connection conn) {

		try {
			if (conn != null) {
				conn.close();
			}
		} catch (SQLException err) {

			err.printStackTrace();
		}
	}

	/**
	 * ͷԴ
	 * @param rs
	 * @param st
	 * @param conn
	 */

	public static void free(ResultSet rs, Statement st, Connection conn) {
		free(rs);
		free(st);
		free(conn);
	}

	/**
	 * INSERTƴӹ
	 * @param tableName
	 * @param fieldsMap
	 * @return
	 */
	public static String prepareInsertSql(String tableName,
			Map<String, Object> fieldsMap) {
		StringBuilder keys = new StringBuilder();
		StringBuilder values = new StringBuilder();
		for (Entry<String, Object> entry : fieldsMap.entrySet()) {
			keys.append(entry.getKey()).append(',');
			values.append("'").append(entry.getValue()).append("',");
		}
		keys.deleteCharAt(keys.length() - 1);
		values.deleteCharAt(values.length() - 1);
		return String.format("INSERT INTO %s(%s) values(%s)", tableName,
				keys.toString(), values.toString());
	}

}
